
6 => int numFreqs;
2 => int replication;
40::ms => dur step;

[ 300, 600, 900, 1200, 1500, 1800 ] @=> int freqs[];

1800 => int center;

SinOsc osc[numFreqs * replication];
for (0 => int i; i < numFreqs; i++) {
  for (0 => int j; j < replication; j++) {
    freqs[i] << j => osc[i * replication + j].freq;
    osc[i * replication + j] => dac;
  }
}

while (true) {
  step => now;
  for (0 => int i; i < numFreqs; i++) {
    for (0 => int j; j < replication; j++) {
      center << j => float baseFreq;
      osc[i * replication + j].freq() * 0.99 => float nextFreq;
      if (nextFreq < baseFreq) {
        nextFreq * 2 => nextFreq;
      }

      Std.fabs(center - Std.ftom(nextFreq)) / 2.0 => float vol;
      // (1.0 - (vol / 20.0)) => vol;
      if (vol < 0) 0 => vol;
      vol => osc[i * replication + j].gain;
      nextFreq => osc[i * replication + j].freq;
    }
  }
}
